#include <stddef.h>

#define QUOTED_PRINTED

#ifndef QUOTED_PRINTED
#define ASCII_PAD_CHAR 'A'
  /*
   To ensure that the encoded data is XML friendly, ensure that the
   '<' and '>' characters do not figure anywhere within the
ASCII_PAD_CHAR
   and (ASCII_PAD_CHAR + 15) range
  */
#endif

// Author: Unknown


char
toNormal(char ch)
{
#ifdef QUOTED_PRINTED
  if(ch <= '9')
    ch -= '0';
  else ch -= ('A' - 10);
#else
  ch -= ASCII_PAD_CHAR;
#endif
  return ch;
}


char
toPrintable(char ch)
{
#ifdef QUOTED_PRINTED
  if(ch < 10)
    ch += '0';
  else  ch += ('A' - 10);
#else
  ch += ASCII_PAD_CHAR;
#endif
  return ch;
}



void
encodeAsString(void *byteStream, size_t size, char *string)
{
  unsigned char *binPtr = (unsigned char *)byteStream;
  int i, j;
  for(i = 0, j = 0; i < size; i++)
  {
    int upperNibble, lowerNibble;
    upperNibble = binPtr[i]/0x10;
    lowerNibble = binPtr[i]%0x10;
   
    string[j++]= toPrintable(upperNibble);
    string[j++]= toPrintable(lowerNibble);
  } string[j] = '\0'; /* Null terminate the string */
}


void
decodeFromString(char *string, void *byteStream)
{
  /* Size information is not passed since the string
     is asumed to be NULL terminated */
  char *binPtr = (char *)byteStream;
  int strSize = strlen(string);
  int i = 0, j = 0;

  for(i = 0, j = 0; i < strSize; i+=2, j++)
  {
    char upperNibble = toNormal(string[i]);
    char lowerNibble = toNormal(string[i+1]);
    binPtr[j] = upperNibble * 0x10 + lowerNibble;
  }
}

/****************** Source code end **********/